/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.45 by edhill, Sat Jul 17 02:08:45 2004 UTC revision 1.132 by jmc, Thu Jan 14 23:17:42 2010 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
37      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
38        echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41        echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 34  usage() Line 48  usage()
48      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
49      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
50      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
51        echo "  (-ts)                    provide timing information per timestep"
52        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
53        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
54      echo      echo
55      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING can be a whitespace-delimited list"
56      echo "such as:"      echo "such as:"
57        echo
58      echo "  -t 'exp0 exp2 exp3' "      echo "  -t 'exp0 exp2 exp3' "
59      echo "  -addr='abc@123.com testing@home.org'"      echo "  -addr='abc@123.com testing@home.org'"
60      echo      echo
61        echo "provided that the expression is properly quoted within the current"
62        echo "shell (note the use of single quotes to protect white space)."
63        echo
64      exit 1      exit 1
65  }  }
66    
# Line 47  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 56  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 70  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_for_prop()  testoutput_var()
104  {  {
105      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
109        #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
112          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
113      fi      fi
114      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
121              return 99              return 99
122          fi          fi
123      else      else
124          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
136          return 99          return 99
137      fi      fi
138        if [ $lncntA -ne $lncntB ]; then
139            if [ $verbose -gt 0 ]; then
140                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
141            fi
142            return 99
143        fi
144        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
145        if [ $has_nan -gt 0  ] ; then
146            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
147            return 99
148        fi
149        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
150        if [ $has_inf -gt 0  ] ; then
151            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
152            return 99
153        fi
154      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
155          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
156      fi      fi
157      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
158      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
159          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
160      fi      fi
161      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
162          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 124  testoutput_for_prop() Line 164  testoutput_for_prop()
164      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
165      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
166      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
167      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 140  testoutput_for_prop() Line 180  testoutput_for_prop()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
183  dashnum()  testoutput_run()
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tmp_cmpnum < t5.txt`  
     digits_6=`./tmp_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
 testoutput()  
184  {  {
185      # testoutput directory subdir extension      # testoutput_run directory subdir reference_output
186      #      #
187      #  test output in "directory"      #  test output from 1 run in "directory"
188      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
189          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
190              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
191          fi          #  others : number of matching digits to be printed in summary.txt
192          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
193          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
194              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195          fi          sVar=`echo $listChk | awk '{print $1}'`
196          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
197          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          # check for ptracer output in reference_output file :
201          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?          outpref=$1/results/$3
202          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?          for ii in $PTRACERS_NUM ; do
205          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?              ptrfound=0
206          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?              for jj in $ptr_mon ; do
207          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?              done
211          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?              if test $ptrfound = '1' ; then
212          dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \                  eval "HAVE_PTR0"$ii"=t"
213              $umin $umax $umean $usd $vmin $vmax $vmean $vsd              else
214      else                  eval "HAVE_PTR0"$ii"=f"
215          testoutput_ad $1 $2 "precision_grdchk_result"                if test "x$ADM" = x -a "x$OADM" = x; then
216      fi                # remove this ptr from the list of output variable to check
217                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  fi
220                fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222            done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224            if test $tst != 1 ; then
225              if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226                     else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
227              echo "==> WARNING: in checked list:" $listVar 1>&2
228            #- put it back once:
229              listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
230            fi
231            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
232            echo "listVar='$listVar'" > $CDIR"/summary.txt"
233            allargs=""
234            for xx in $listVar
235            do
236              case $xx in
237               'PS')  if [ $debug -gt 0 ]
238                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
263            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286              esac
287              if test $xx = $sVar
288              then allargs="$allargs > $yy <"
289              else allargs="$allargs $yy"
290              fi
291            done
292    
293            nbVar=`echo $listVar | awk '{print NF}'`
294            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295            #-- fill line (up to standard length) with dot:
296              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297              echo $allargs $adNul
298            else
299              echo $allargs
300            fi
301    # <-- same processing for adjoint & forward test
302  }  }
303    
304  genmakemodel()  genmakemodel()
# Line 221  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                  command="$command -adof=../../../tools/adjoint_options/adjoint_staf"              elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
327              fi              fi
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334                if test "x$MPI" = xt ; then
335                    command="$command -mpi"
336                fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341                if test "x$TS" = xt ; then
342                    command="$command -ts"
343                fi
344                if test "x$PAPIS" = xt ; then
345                    command="$command -papis"
346                else
347                if test "x$PCLS" = xt ; then
348                    command="$command -pcls"
349                fi
350                fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              #  cp Makefile $CDIR              head -100 Makefile > $CDIR/Makefile_head
357              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
358                  tail make.log                  tail make.log
359                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed" 1>&2
# Line 254  makeclean() Line 370  makeclean()
370  {  {
371      # makeclean directory      # makeclean directory
372      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
373          echo "make CLEAN skipped!"          echo "make Clean skipped!"
374      else      else
375          (          (
376              cd $1;              cd $1;
377              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
378              if test -r Makefile ; then              if test -r Makefile ; then
379                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
380                    $MAKE Clean >> make.log 2>&1
381                  RETVAL=$?                  RETVAL=$?
382                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
383                      tail make.log                      tail make.log
384                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
385                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
386                      return 1                      return 1
387                  fi                  fi
388                    echo successful 1>&2
389                else
390                    echo ''
391              fi              fi
392                exit 0
393            )
394        fi
395    }
396    
397    run_clean()
398    {
399        # run_clean directory
400        if test "x$NOCLEAN" = xt ; then
401            echo "run_clean skipped!"
402        else
403            (
404                cd $1;
405                printf 'clean run-dir ... ' 2>&1
406                # part of what is done after "make clean" when doing "make CLEAN"
407                find . -name "*.meta" -exec rm {} \;
408                find . -name "*.data" -exec rm {} \;
409                find . -name "fort.*" -exec rm {} \;
410                find . -type l -exec rm {} \;
411                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
412                rm -rf mnc_test_*
413                rm -f *_MIT_CE_000.opt0000 costfunction*0000
414              echo successful 1>&2              echo successful 1>&2
415              exit 0              exit 0
416          )          )
# Line 308  makemodel() Line 447  makemodel()
447          cd $1;          cd $1;
448          if test -r Makefile ; then          if test -r Makefile ; then
449              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
450              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
451                    $MAKE adall >> make.log 2>&1
452                elif test "x$OADM" = xt ; then
453                    $MAKE adAll >> make.log 2>&1
454                else
455                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
456                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
457                  else                  else
458                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
459                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
460              fi              fi
461              RETVAL=$?              RETVAL=$?
462              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
463                  tail make.log                  tail make.log
464                  echo failed 1>&2                  echo failed 1>&2
465                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
466                    rm -f $EXECUTABLE
467                  return 1                  return 1
468              else              else
469                  echo successful 1>&2                  echo successful 1>&2
# Line 342  symlink_mpifiles() Line 484  symlink_mpifiles()
484      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
485            
486      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
487      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
488    
489      #  Is this an MPI run?      #  Is this an MPI run?
490      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 380  symlink_mpifiles() Line 522  symlink_mpifiles()
522    
523  linkdata()  linkdata()
524  {  {
525      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
526      #      #
527      # symbolically link data files to run directory      # symbolically link data files to run directory
528      if test "x$1" = x1 ; then      if test -d $1 ; then
529          (          (
530              cd $2              cd $1 ; shift
531              if test "x$ADM" = x ; then              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
532                  files=`( cd ../input ; ls -1 | grep -v CVS )`              for xx in $inpMPI ; do
533                  for i in $files ; do                if test -r "../"$1"/"$xx ; then
534                      if test ! -d "../input/"$i ; then                  # found 1 _mpi sfx file in 1rst input dir and it is readable
535                          ln -sf "../input/"$i $i                  yy=`echo $xx | sed 's:\.mpi$::'`
536                      fi                  if test "x$MPI" = "xt" ; then
537                  done                  # mpi test: remove symbolic link & link _mpi sfx file
538              else                      if test -h $yy ; then rm -f $yy ; fi
539                  files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`                      if test ! -r $yy ; then
540                  for i in $files ; do                          ln -sf "../"$1"/"$xx $yy ;
541                      if test ! -d "../input/"$i ; then                          printf "$xx " 1>&2
                         ln -sf "../input/"$i $i  
542                      fi                      fi
543                  done                  else
544                  files=`( cd ../input_ad ; ls -1 | grep -v CVS )`                  # not mpi test: remove symbolic link
545                  for i in $files ; do                      if test -h $yy ; then rm -f $yy ; fi
546                      if test ! -d "../input_ad/"$i ; then                  fi
547                          ln -sf "../input_ad/"$i $i                fi
548                done
549                if test -r "../"$1"/eedata.mth" ; then
550                # found eedata.mth in 1rst input dir and it is readable
551                    if test "x$MULTI_THREAD" = "xt" ; then
552                    # multi-threaded test: remove symbolic link & link eedata.mth
553                        if test -h eedata ; then rm -f eedata ; fi
554                        if test ! -r eedata ; then
555                            ln -sf "../"$1"/eedata.mth" eedata ;
556                            printf 'eedata.mth ' 1>&2
557                      fi                      fi
558                  done                  else
559                    # not multi-threaded test: remove eedata symbolic link
560                        if test -h eedata ; then rm -f eedata ; fi
561                    fi
562              fi              fi
563                prevDir='NONE'
564                for ldir in $* ; do
565                    if test -d "../"$ldir -a $ldir != $prevDir ; then
566                        printf 'ldir='${ldir} 1>&2
567                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
568                        for i in $files ; do
569                            if test ! -d "../"$ldir/$i ; then
570                                if test ! -r $i  ; then
571                                    printf ' '$i 1>&2
572                                    ln -sf "../"$ldir"/"$i $i
573                                fi
574                            fi
575                        done
576                        if test -x "../"$ldir"/"prepare_run ; then
577                            "../"$ldir"/"prepare_run
578                        fi
579                        printf ' ; ' 1>&2
580                    fi
581                    prevDir=$ldir
582                done
583          )          )
584      fi      fi
585  }  }
# Line 419  runmodel() Line 592  runmodel()
592      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
593      (      (
594          cd $1          cd $1
595          printf 'runmodel ... ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
596          # make output.txt          # make output.txt
597          echo          echo
598          # echo "COMMAND='$COMMAND'"          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
599          # echo "pwd='"`pwd`"'"              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
600          ( eval $COMMAND ) >> run.log 2>&1              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
601          RETVAL=$?          fi
602          if test "x$RETVAL" = x0 ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
603                echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
604                ln -sf "../"$builddir"/"$EXECUTABLE .
605            fi
606            if test ! -x $EXECUTABLE ; then
607                    rm -f $RUNLOG ; touch $RUNLOG
608                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
609                    echo " no executable:" $EXECUTABLE >> $RUNLOG
610                    RETVAL=8
611                    ENDVAL=-1
612            else
613                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
614                  # output do not exist or is older than executable:
615                    rm -f $RUNLOG ; touch $RUNLOG
616                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
617                    ( eval $COMMAND ) >> $RUNLOG 2>&1
618                    RETVAL=$?
619                else
620                    RETVAL=0
621                    if test -f $RUNLOG ; then
622                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
623                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
624                    else
625                        touch $RUNLOG
626                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
627                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
628                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
629                    fi
630                fi
631                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
632            fi
633            rm -f run.log_tmp
634            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
635                tail $RUNLOG
636              echo successful 1>&2              echo successful 1>&2
637              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
638              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
639              #   cp output.txt $CDIR"/output.txt"              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
640              # else              return 0
641              #   cp output.txt_adm $CDIR"/output.txt_adm"          elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
642              # fi              #-- for some weird cases (run is finihed but with error code)
643                tail $RUNLOG
644                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
645              return 0              return 0
646          else          else
647              tail run.log              tail $RUNLOG
648              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
649              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
650                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
651              return 1              return 1
652          fi          fi
653      )      )
# Line 448  createcodelet() Line 657  createcodelet()
657  {  {
658      # create codelet for comparing model output      # create codelet for comparing model output
659    
660      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
661      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
662  #include <stdio.h>  #include <stdio.h>
663  #include <math.h>  #include <math.h>
664  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
665    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
666    double a,b,diff;    double a,b,abave,relerr;
667    best = -16;    best = -22;
668    lncnt = 0;    lncnt = 0;
669    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
670      scanf("%d", &linnum);      scanf("%d", &linnum);
671      if (linnum == -1)  break;      if (linnum == -1)  break;
672      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
673      diff = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
674      if (diff > 1.e-12) {      if ( abave == abave ) {
675        diff=fabs(a-b)/diff;        if (abave > 0.0) {
676        if (diff > 0.0) {          relerr=fabs(a-b)/abave;
677          linnum = (int)log10(diff);          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
678          best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
679        }          best = (best > cmplin) ? best : cmplin; }
680        else {        else { cmplin = -22 ; }
681          if (best == -16 && diff != 0)  best = -22;     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
682        }        }
683      }     else {
684       /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
685          break; }
686    }    }
687    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
688      if (linnum != -1) best=-99;
689    printf("%d\n", -best);    printf("%d\n", -best);
690    return 0;    return 0;
691  }  }
692  EOF  EOF
693      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
694    
695      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
696          echo "OK"          echo "OK"
697          return 0          return 0
698      else      else
699          echo          echo
700          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
701            echo "  a C compiler using the CC environment variable."
702          exit 1          exit 1
703      fi      fi
704  }  }
# Line 497  formatresults() Line 710  formatresults()
710      nm=$1      nm=$1
711      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
712      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
713      printf '%3s' $@      listPrt=$@
714        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
715        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
716        printf '%3s' $listPrt
717    #   line below does not work on hp-ux_ia64 : do those substitutions later on
718    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
719            
720      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
721            printf ' N/O '
722        elif [ $xx = '--' ]; then
723            printf ' N/O '
724        elif [ $xx = 99 ]; then
725          printf ' N/O '          printf ' N/O '
726      else      else
727          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
728              printf ' pass'              printf ' pass'
729          else          else
730              printf ' FAIL'              printf ' FAIL'
# Line 513  formatresults() Line 735  formatresults()
735            
736  }  }
737    
738  show_help()  scandirs()
739  {  {
740      cat - << EOF      if [ $# -eq 1 ]; then
741  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
742                test -f $arg/$1 && echo $arg
743   -help|-h      Show this help message          done
744   -quiet     Reduce the amount of output      else
745   -verbose   Produce copious amounts of output          echo $*
746   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
747  }  }
748    
749  scandirs()  
750    check_eedata()
751  {  {
752      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
753          for arg in * ; do      if [ $# -eq 2 ] ; then
754              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
755          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
756          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
757          if test "x$nx" = x ; then
758            rx=10
759          else
760            rx=`expr $sx % $nx`
761          fi
762          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
763          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
764          if test "x$ny" = x ; then
765            ry=20
766          else
767            ry=`expr $sy % $ny`
768          fi
769          echo `expr $rx + $ry`
770        else
771          echo '-1'
772          fi
773      else      else
774          echo $*        echo '-2'
775      fi      fi
 }  
776    
777    }
778    
779  ###############################################################################  ###############################################################################
780    
# Line 551  scandirs() Line 783  scandirs()
783  debug=0  debug=0
784  verbose=1  verbose=1
785  clean=0  clean=0
 expts=''  
 # ieee=1  
786    
787  IEEE=true  IEEE=true
788  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
789      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
790  fi  fi
791    GSL=f
792    
793  CLEANUP=f  CLEANUP=f
794  QUICK=f  QUICK=f
795  NOGENMAKE=f  NOGENMAKE=f
796  NOCLEAN=f  NOCLEAN=f
797  NODEPEND=f  NODEPEND=f
798    POSTCLEAN=f
799    
800  BASH=  BASH=
801  OPTFILE=NONE  OPTFILE=NONE
802  ADDRESSES=  ADDRESSES=
803  TESTDIRS=  TESTDIRS=
804    SKIPDIRS=
805  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
806  HAVE_MPACK=  HAVE_MPACK=
807  MPACK="$MPACKDIR/mpack"  MPACK=
808  COMMAND=  COMMAND=
809  MAKE=make  if test "x$MAKE" = x ; then
810        MAKE=make
811    fi
812    if test "x$CC" = x ; then
813        CC=cc
814    fi
815  JOBS=  JOBS=
816  MPI=f  MPI=f
817    MULTI_THREAD=f
818    OUTDIR=
819  DELDIR=  DELDIR=
820    
821  ADM=  ADM=
822    OADM=
823    
824    # list of pTracers to check for monitor output
825    PTRACERS_NUM="1 2 3 4 5"
826    
827    MATCH_CRIT=13
828    
829  printf "parsing options...  "  printf "parsing options...  "
830    
# Line 609  for ac_option ; do Line 854  for ac_option ; do
854              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
855          -addr=* | --addr=*)          -addr=* | --addr=*)
856              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
857            -mpackdir | --mpackdir | -mpd | --mpd)
858                ac_prev=MPACKDIR ;;
859            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
860                MPACKDIR=$ac_optarg ;;
861    
862          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
863              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
864          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
865              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
866    
867            -skipdir | --skipdir | -skd | --skd)
868                ac_prev=SKIPDIRS ;;
869            -skipdir=* | --skipdir=*)
870                SKIPDIRS=$ac_optarg ;;
871    
872          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
873              ac_prev=BASH ;;              ac_prev=BASH ;;
874          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 630  for ac_option ; do Line 884  for ac_option ; do
884          -make=* | --make=*)          -make=* | --make=*)
885              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
886    
887            -odir | --odir)
888                ac_prev=OUTDIR ;;
889            -odir=* | --odir=*)
890                OUTDIR=$ac_optarg ;;
891    
892            -ptracers | --ptracers | -ptr | --ptr)
893                ac_prev=PTRACERS_NUM ;;
894            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
895                PTRACERS_NUM=$ac_optarg ;;
896    
897            -match | --match ) ac_prev=MATCH_CRIT ;;
898            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
899    
900          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
901          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
902    
903          -clean | --clean)          -clean | --clean)
904              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
905    
906          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
907              QUICK=t ;;              QUICK=t ;;
# Line 645  for ac_option ; do Line 912  for ac_option ; do
912          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
913              NODEPEND=t ;;              NODEPEND=t ;;
914    
915            -postclean | --postclean | -pc | --pc)
916                POSTCLEAN=t ;;
917    
918          -mpi) MPI=t ;;          -mpi) MPI=t ;;
919    
920            -mth) MULTI_THREAD=t ;;
921    
922          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
923    
924            -oad) OADM=t; NODEPEND=t ;;
925    
926          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
927          -noieee) IEEE= ;;          -noieee) IEEE= ;;
928            -gsl) GSL=t ;;
929    
930          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
931          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 658  for ac_option ; do Line 933  for ac_option ; do
933    
934          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
935    
936            -ts) TS=t;;
937    
938            -papis) PAPIS=t;;
939    
940            -pcls) PCL=t;;
941    
942          -*)          -*)
943              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
944              usage              usage
# Line 678  if test "x$QUICK" = xt ; then Line 959  if test "x$QUICK" = xt ; then
959      NODEPEND=t      NODEPEND=t
960  fi  fi
961    
962    #- setting for forward or ADM testing
963    if test "x$ADM" = xt ; then
964        code_dir=code_ad
965        inputdir=input_ad
966        ref_outp="output_adm.txt"
967        EXECUTABLE="mitgcmuv_ad"
968    elif test "x$OADM" = xt ; then
969        code_dir=code_oad
970        inputdir=input_oad
971        ref_outp="output_oadm.txt"
972        EXECUTABLE="mitgcmuv_ad"
973    else
974        code_dir=code
975        inputdir=input
976        ref_outp="output.txt"
977        EXECUTABLE="mitgcmuv"
978    fi
979    
980  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
981      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
982    else
983        #- expand group of experiments:
984        LIST=" "
985        for xx in $TESTDIRS
986        do
987          case $xx in
988            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
989                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
990                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
991                    ;;
992            'tutorials')
993                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
994            *)       LIST=${LIST}" "$xx ;;
995          esac
996        done
997  fi  fi
998    #echo 'LIST='${LIST}'<'
999    #- skip dirs, remove duplicate and non-directory:
1000    TESTDIRS=" "
1001    count=0
1002    for xx in $LIST
1003    do
1004        yy=`echo $SKIPDIRS | grep -c $xx`
1005        if test $yy = 0 ; then
1006            if test -d $xx ; then
1007                yy=`echo $TESTDIRS | grep -c $xx`
1008                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1009            else count=1 ;
1010                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1011            fi
1012        else
1013            if test $count = 1 ; then echo -n ", \"$xx\""
1014            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1015            fi
1016        fi
1017    done
1018    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1019    #echo 'TESTDIRS='${TESTDIRS}'<'
1020    
1021  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1022      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1023  fi  fi
1024    
1025  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  RUNLOG="run.log"
1026      COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"  OUTPUTFILE=$ref_outp
 fi  
   
1027  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1028      COMMAND="$MAKE output.txt"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1029  fi  fi
1030    if test "x$MPI" = xt ; then
1031        OUTPUTFILE="STDOUT.0000"
1032    fi
1033    
1034    echo "OK (COMMAND= $COMMAND )"
1035    
1036  echo "OK"  # set the Default List of output variables to be checked:
1037    #  (use default or load experiment-specific list from file "tr_checklist")
1038    # content : 1rst = main variable used to decide if it pass or FAIL
1039    #         others = number of matching digits to be printed in summary.txt
1040    if test "x$ADM" = x -a "x$OADM" = x; then
1041        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1042        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1043        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1044        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1045        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1046    else
1047        DEF_CHECK_LIST='Grad Cost Grad'
1048        EMPTY_RESULTS='.. ..'
1049        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1050    fi
1051    
1052  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1053  createcodelet  createcodelet
1054    
1055  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1056  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1057      echo "skipping mpack build"      echo "skipping mpack build"
1058  else  else
1059      build_mpack      build_mpack
1060  fi  fi
1061    
1062  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1063    CMDLINE=$0
1064    for xx in "$@" ; do nw=`echo $xx | wc -w`
1065        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1066                            else CMDLINE="$CMDLINE '$xx'" ; fi
1067    done
1068    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1069  MACH=`hostname`  MACH=`hostname`
1070  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1071  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1072  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1073    if test "x$OUTDIR" != x ; then
1074        BASE="tr_"$OUTDIR"_"$DATE"_"
1075    else
1076        short_name=`hostname | sed 's/\..*$//'`
1077        BASE="tr_"$short_name"_"$DATE"_"
1078    fi
1079  DNUM=0  DNUM=0
1080  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1081  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 724  if test "x$RETVAL" != x0 ; then Line 1089  if test "x$RETVAL" != x0 ; then
1089      exit 1      exit 1
1090  fi  fi
1091  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1092  start_date=`date`  start_date=`date`
1093  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1094    echo 'run:' $CMDLINE >> $SUMMARY
1095    echo 'on :' $UNAMEA  >> $SUMMARY
1096    
1097  of_path=  of_path=
1098  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 755  else Line 1121  else
1121  fi  fi
1122  echo  echo
1123  echo >> $SUMMARY  echo >> $SUMMARY
1124  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1125      cat << EOF | tee -a $SUMMARY      if [ $MATCH_CRIT -lt 10 ] ;
1126                  T           S           U           V      then line_0="default  "$MATCH_CRIT ;
1127  G D M    c        m  s        m  s        m  s        m  s      else line_0="default "$MATCH_CRIT ; fi
1128  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1129  N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1130  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .      line_1="G D M    c        m  s        m  s        m  s        m  s"
1131        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1132  EOF      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1133        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1134        for ii in $PTRACERS_NUM ; do
1135            line_0="$line_0  --PTR 0"$ii"--"
1136            line_1="$line_1        m  s"
1137            line_2="$line_2  m  m  e  ."
1138            line_3="$line_3  i  a  a  d"
1139            line_4="$line_4  n  x  n  ."
1140        done
1141        echo "$line_0" | tee -a $SUMMARY
1142        echo "$line_1" | tee -a $SUMMARY
1143        echo "$line_2" | tee -a $SUMMARY
1144        echo "$line_3" | tee -a $SUMMARY
1145        echo "$line_4" | tee -a $SUMMARY
1146        echo " "       | tee -a $SUMMARY
1147  else  else
1148      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1149      echo >> $SUMMARY      echo >> $SUMMARY
1150        if [ $MATCH_CRIT -lt 10 ] ;
1151        then line_0="default     "$MATCH_CRIT ;
1152        else line_0="default    "$MATCH_CRIT ; fi
1153        echo "$line_0" | tee -a $SUMMARY
1154      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1155  G D M    C  G  G D M    C  G
1156  E p a R  o  r  E p a R  o  r
# Line 779  fi Line 1163  fi
1163  #  ...and each test directory...  #  ...and each test directory...
1164  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1165            
1166        # set builddir & rundir:
1167        builddir="build"
1168        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1169        rundir="run"
1170        if test ! -d $dir/$rundir ; then
1171            rundir=$builddir
1172        fi
1173        CODE_DIR=$dir/$code_dir
1174        BUILD_DIR=$dir/$builddir
1175    
1176      #  Cleanup only!      #  Cleanup only!
1177      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1178          if test -r $dir/build/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1179              ( cd $dir/build ; make CLEAN )          makeclean $BUILD_DIR
1180            rm -f $BUILD_DIR/$EXECUTABLE
1181            if test -d $dir/$rundir/CVS ; then
1182                echo -n '  --- dir:' $dir/$rundir ': '
1183                run_clean $dir/$rundir
1184          fi          fi
1185          if test -r $dir/input/Makefile ; then          trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1186              ( cd $dir/input ; make CLEAN )          ttd=`echo $trdir | wc -w`
1187            if test $ttd != 0 ; then
1188                echo '  --- rm dir:' $trdir
1189                ( cd $dir ; rm -rf $trdir )
1190          fi          fi
1191          continue          continue
1192      fi      fi
1193    
1194      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1195      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1196      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output.txt_adm"  
     fi  
1197      if test ! -r $fout ; then      if test ! -r $fout ; then
1198          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1199          continue          continue
1200      fi      fi
1201    
1202      builddir="input"      # Check for specific files for particular type of run
     rundir="input"  
     use_seperate_build=0  
     if test -d $dir/build -a -r $dir/build ; then  
         builddir="build"  
         rundir="build"  
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
     fi  
       
     #  Check whether there are "extra runs" for this testdir  
     extra_runs=  
     if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then  
         ex_run_dirs=`( cd $dir ; echo input.* )`  
         echo "ex_run_dirs='$ex_run_dirs'"  
         for exd in $ex_run_dirs ; do  
             name=`echo $exd | sed -e 's/input.//g'`  
             outf="$dir/results/output.txt.$name"  
             if test -f $outf -a -r $outf ; then  
                 extra_runs="$extra_runs $name"  
             fi  
         done  
     fi  
   
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
     fi  
     BUILD_DIR=$dir/$builddir  
1203    
1204      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1205          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1206          continue          continue
1207      fi      fi
1208        if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1209            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1210            continue
1211        fi
1212        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1213          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1214          if test $retv != 0 ; then
1215            echo "input/eedata.mth tiling misfit -- skipping $dir"
1216            continue
1217          fi
1218        fi
1219    
1220        #  Check whether there are "extra runs" for this testdir
1221        extra_runs=
1222        ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1223        #echo "ex_run_dirs='$ex_run_dirs'"
1224        for exd in $ex_run_dirs ; do
1225            name=`echo $exd | sed -e "s/$inputdir\.//"`
1226            refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1227            outf="$dir/results/$refExOut"
1228            if test -f $outf -a -r $outf ; then
1229              if test "x$MULTI_THREAD" = "xt" ; then
1230                if test -r $dir"/"$exd"/eedata.mth" ; then
1231                  if test "x$MPI" = "xt" ; then
1232                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1233                    if test $retv = 0 ; then
1234                        extra_runs="$extra_runs $name"
1235                    else
1236                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1237                    fi
1238                  else
1239                    extra_runs="$extra_runs $name"
1240                  fi
1241                #else echo $dir"/"$exd"/eedata.mth: not found"
1242                fi
1243              else
1244                extra_runs="$extra_runs $name"
1245              fi
1246            fi
1247        done
1248    
1249      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1250      echo      echo
1251      echo "Experiment:  $dir"      if test "x$extra_runs" = "x" ; then
1252           echo "Experiment:  $dir"
1253        else
1254           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1255        fi
1256      echo      echo
1257      unset genmake makedepend make run      unset genmake makedepend make run
1258      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1259    
1260      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1261      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 854  for dir in $TESTDIRS ; do Line 1263  for dir in $TESTDIRS ; do
1263      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1264            
1265      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1266          makeclean $dir/$builddir          echo '====>>> this is to check that we never go through this part <<< ==='
1267            makeclean $dir/$builddir \
1268                && run_clean $dir/$rundir
1269      else      else
1270          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1271              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1272                && run_clean $dir/$rundir \
1273              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1274              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1275              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1276              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1277              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1278              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1279      fi      fi
1280            
1281      echo      echo
     if test "x$ADM" = x ; then  
1282          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1283          echo          echo
1284          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1285          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1286            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1287          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1288          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1289          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1290          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1291            if test "x$ADM" = xt ; then
1292                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1293                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1294                                    >> $CDIR"/summary.txt"
1295            fi
1296    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1297          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1298              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              unset run
1299              mkdir "$dir/tr_run.$ex"              results=$EMPTY_RESULTS
1300              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              #  reference output file
1301              (              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1302                  cd "$dir/tr_run.$ex"              #  Create an output dir for each OPTFILE/tdir.ex combination
1303                  for i in $links; do              rel_CDIR=$DRESULTS"/"$dir"."$ex
1304                      ln -s ../input/$i $i              mkdir $rel_CDIR
1305                  done              CDIR=`pwd`"/$rel_CDIR"
1306              )              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1307              links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              run_clean $dir/tr_run.$ex
1308              (              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
             )  
1309              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1310                  && results=`testoutput $dir tr_run.$ex "."$ex`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1311              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1312              fres="$fres.$ex"              fres="$fres.$ex"
1313              echo              echo
1314              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1315              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1316                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1317              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1318              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1319              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1320              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1321                if test "x$ADM" = xt ; then
1322                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1323                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1324                                       >> $CDIR"/summary.txt"
1325                fi
1326                if test "x$POSTCLEAN" = xt ; then
1327                    run_clean $dir/tr_run.$ex
1328                fi
1329          done          done
1330          COMMAND=$OLD_COMMAND  
1331      else      #postclean $dir/$builddir
1332          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`      if test "x$POSTCLEAN" = xt ; then
1333          fres=$fres"$results   $dir"          makeclean $dir/$builddir \
1334          echo              && run_clean $dir/$rundir
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
1335      fi      fi
1336            
1337      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
# Line 929  for dir in $TESTDIRS ; do Line 1339  for dir in $TESTDIRS ; do
1339  done  done
1340    
1341  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1342  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1343  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1344  date >> $SUMMARY  date >> $SUMMARY
1345    
# Line 954  else Line 1364  else
1364              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1365              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1366              echo              echo
1367                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1368                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1369          fi          fi
         test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"  
         test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"  
1370      fi      fi
1371  fi  fi
1372    
1373  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1374    
1375  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1376      cat $SUMMARY      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1377      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1378          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1379      fi      fi
1380      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1381  fi  fi
1382    
1383  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.45  
changed lines
  Added in v.1.132

  ViewVC Help
Powered by ViewVC 1.1.22